#
#    64bitOSでrpmbuildする際に以下を指定します。
#	32bit版	linux32 rpmbuild -ba --define 'MACHINE i686' <specfile>
#	64bit版	rpmbuild -ba --define 'MACHINE x86_64' <specfile>
#    32bitOSでrpmbuildする際に以下を指定します。
#	rpmbuild -ba  --define 'MACHINE i686' <specfile>
#
# rpmbuild 環境
# /home/rpm/.rpmmacros
#	%_build_name_fmt        %%{ARCH}/%%{NAME}-%%{VERSION}-%%{RELEASE}%{dist}.%%{ARCH}.rpm
#
# # rpmbuild --showrc | less で確認する。

%define MACHINE x86_64
%ifarch i686
%define MACHINE i686
%endif

%define __requires_exclude libc.so.6(GLIBC_PRIVATE)

%global __filter_GLIBC_PRIVATE 1

# ********* 基本情報 *********
#パッケージの簡単な説明を英語で記述します。
Summary:gconv-digital-tv is character conversion module for Digital TV application(s).

# Summaryを日本語で翻訳します。
Summary(ja): gconv-digital-tvは、デジタルTVアプリケーションで必要とされる文字コード変換モジュールです。

# パッケージの名前です。定義以降、%%{name}というマクロで参照できます。
Name:gconv-digital-tv

# パッケージのバージョンです。定義以降、%%{version}というマクロで参照できます。
Version: 2.0.1

# 冒頭の数字は同じバージョンで何回目のリリースになるかを意味します。
# 定義以降、%%{release}というマクロで参照できます。
Release: 1

# アプリケーションのライセンス
License: LGPL v2.1

# アプリケーションの種類。
# Group - /usr/share/doc/rpm-xxxx/GROUPS を参照
# Amusements/Games
# Amusements/Graphics
# Applications/Archiving
# Applications/Communications
# Applications/Databases
# Applications/Editors
# Applications/Emulators
# Applications/Engineering
# Applications/File
# Applications/Internet
# Applications/Multimedia
# Applications/Productivity
# Applications/Publishing
# Applications/System
# Applications/Text
# Development/Debuggers
# Development/Languages
# Development/Libraries
# Development/System
# Development/Tools
# Documentation
# System Environment/Base
# System Environment/Daemons
# System Environment/Kernel
# System Environment/Libraries
# System Environment/Shells
# User Interface/Desktops
# User Interface/X
# User Interface/X Hardware Support
Group: Development/Libraries

# アプリケーションの情報を提供しているURL
URL: http://www.minkycute.homeip.net/

# 作成したrpmパッケージに関する責任を負うVendor名です。
Vendor:	-

# ディストリビューション名を指定します。
Distribution: Readhat Enterprise Linux

# パッケージメンテナ。
# 複数のメンテナがいる場合、カンマで区切ります。
Packager: watanabe439@gmail.com

# ********* パッケージの作成時に必要となる情報 *********
# 複数のソースファイルやパッチがあるときはSource0、Source1、...や
# Patch0、Patch1、...というふうに番号をふって列挙します。
# (Source0は、Sourceと省略できます。)
Source: %{name}-%{version}.src.tar.gz

# パッチファイルを指定します。 書式はSourceと同じです。
#Patch: hoge.patch

# 仮想インストールのためのディレクトリ名を書きます。
# 直接ディレクトリ名を書くのではなく、例のようにマクロを利用してください。
BuildRoot: %{_tmppath}/%{name}-%{version}-root

# 依存情報
# 作成しているrpmパッケージが動作するのに必要なパッケージ名
# 複数のパッケージが関係する場合は、カンマ(,)やスペースで区切って列挙したり、
# 複数行に分けて記述できます。複数行に分ける場合は、各行にタグが必要です。
# <, >, =, >=, <=といった演算子を使うとパッケージのバージョン、
# リリース番号を限定することもできます。
# 注：演算子の両側には必ずスペースやタブを入れてください。
#Requires: chkconfig
#Requires: sqlite >= 3.8
#Requires: sysklogd
Requires: perl

#BuildRequires: chkconfig
#Requires(pre): chkconfig
#Requires(post): chkconfig
#Requires(preun): chkconfig

# パッケージの作成時に必要となるパッケージ名
#BuildRequires:	hoge-devel

# 共存できないパッケージ名
#Conflicts

# パッケージ作成時にはインストールしておけないパッケージ名
#BuildConflicts

# 詳しい解説
# Summaryタグの場合と違い、複数行にわたる解説を書くことができます。
%description
digital-tv is character conversion module for Digital TV application(s).
digital-tv adds support for the following character encoding to iconv library.
 * ARIB-B24
 * ARIB-STD-B24
 * EN300-468-TAB00
You can see detail information of ARIB 8unit character-encoding-code from the following URL(s). 
 * http://www.arib.or.jp/english/html/overview/doc/6-STD-B24v5_2-1p3-E1.pdf
 * http://www.arib.or.jp/english/html/overview/sb_ej.html
 * https://sites.google.com/site/unicodesymbols/Home/japanese-tv-symbols/
   *** It is based on ISO-2022, and used in Japanese digital televsion systems.
   *** Note 1: "mosaic" characters are not supported in this module.
   *** Note 2: Control characters (for subtitles) are discarded.
also, you   can see detail information of ARIB 8unit character-encoding-code from the following URL(s).
 * http://www.etsi.org/deliver/etsi_en/300400_300499/300468/01.14.01_60/en_300468v011401p.pdf
   *** It is used in used in European digital televsion systems.

# 日本語による詳しい解説
# Summaryタグの場合と違い、複数行にわたる解説を書くことができます。
%description -l ja
digital-tvは、デジタルTVアプリケーションで必要とされる文字コード変換モジュールです。
digital-tvはiconvライブラリに以下の文字エンコードのサポートを追加します。
  >ARIB-B24
  >ARIB-STD-B24
  >EN300-468-TAB00
ARIB  8単位文字コードの詳細は以下のURLを参照ください。
 * http://www.arib.or.jp/english/html/overview/doc/6-STD-B24v5_2-1p3-E1.pdf
 * http://www.arib.or.jp/english/html/overview/sb_ej.html
 * https://sites.google.com/site/unicodesymbols/Home/japanese-tv-symbols/
   *** ISO-2022をベースとした、日本のデジタルTVで使用される文字コードです。
   *** 注1：モザイクはこのモジュールではサポートしていません。
   *** 注2：文字放送用の制御コードは破棄されます。
EN300-468 文字コードの詳細は以下を参照ください。
 * http://www.etsi.org/deliver/etsi_en/300400_300499/300468/01.14.01_60/en_300468v011401p.pdf
   *** ヨーロッパのデジタルTVで使用される文字コードです。

#
# スクリプト部
#rpmを構築する前の準備です。
%prep

##%ifarch x86_64
%if "%{MACHINE}" == "x86_64"
  %define LIB_DIR /usr/lib64/gconv
%else
  %define LIB_DIR /usr/lib/gconv
%endif

rm -rf ${RPM_BUILD_ROOT}

# ソースをBUILDに展開します。
%setup -c

# パッチをあてます。
# %%patch -p1

# makeのための手順を書きます。
%build
make clean
make MACHINE=%{MACHINE}

#(cd man; make man)

# installのための手順を書きます。
%install
#(cd man; make prefix=${RPM_BUILD_ROOT}/usr/local install.man)
make install PREFIX=$RPM_BUILD_ROOT MACHINE=%{MACHINE}

# install が正しく実行されたかをcheckするスクリプト
# %%check

# rpmを作ったあとの後始末です。
%clean
rm -rf $RPM_BUILD_ROOT

# ファイルリスト部
# RPMパッケージに収録するファイル名を列挙します。
# ファイルを含まないバーチャルパッケージ1を作る場合でも、%%files という行だけは必要になります。
# %%files という行を省略してしまうと、rpmbuild コマンドで処理しても src.rpm しか作れません。 
%files
#
# %%filesに列挙するファイルのパーミッションやuser ID、group IDを設定します。
# 一部の属性を省略(書き換えない)したいときには - を使います。
# %%attr(<mode>,<owner>,<group>[, dirmode]) <file name> 
#
# %%defattr(<mode>,<owner>,<group>[, dirmode])
# それ以降の行に書かれた属性のデフォルト値を設定iします。
#  %%attr が出てきた行を除いて、それ以降に書かれたものに共通になります。
%defattr(-,root,root)

# ドキュメント・ファイルの指定
# %%docというマクロを用います。
# %%doc READMEとすると、 %%setupで指定したホームディレクトリ下のREADMEが、
# ${RPM_BUILD_ROOT}/usr/doc/hoge-1.1-2/にcpされたのち、 rpmパッケージに回収されます。
# つまり%%docは、 ドキュメントファイルのインストールとパッケージングのための
# ファイル指定を同時に行うマクロとしてはたらきます。
# 以下のように、ディレクトリごと指定もできます
# %%doc %%{name}.1.gz

# パッケージに収録するファイルの指定
# ここに書くファイル名は重複してはいけません。 
# 列挙されたファイルは、%%docで指定するものを除いて、 
# %%installまでのスクリプトの実行によって、 記述した通りの場所
# (${RPM_BUILD_ROOT}を''/''とみなす) にinstallされるものでないといけません。 
# 列挙されたファイルがおかしな userID/groupID を持っていると、 
# rpmパッケージが正常にbuildできないことがあります。 
# 空のディレクトリを作成する場合は %%dir /opt/%%{name}/bin/
# %%dir /usr/local/%{name}/log/

%{LIB_DIR}/gconv-modules.arib
%{LIB_DIR}/ARIB-STD-B24.so
%{LIB_DIR}/EN300_468_TAB00.so
/tmp/install_mod.sh

# コンフィグファイルが書き換えられていた場合、 
# アンインストール時には 
# %%config		旧ファイルは.rpmsaveをつけた名前で保存されます。
# %%config(noreplace)	新ファイルは.prmnewを付けた名前で保存されます。
# アップグレード時には新しいファイルと置き換えられ、
#  元のファイルは .rpmsaveをつけた名前で保存されます。
# %%config(noreplace) /usr/local/%{name}/conf/channel.conf

# アップグレードの際の注意
# アップグレードの際のオペレーションの順序は以下のとおりです。
#    インストールされる RPM の %pre セクションを実行します。
#    RPM が提供するファイルをインストールします。
#    RPM の %post セクションを実行します。
#    古いパッケージの %preun を実行します。
#    新しいバージョンによって上書きされなかった古いファイルをすべて削除します。
#    (このステップによって、新しいパッケージに不要のファイルが削除されます。)
#    古いパッケージの %postun フックを実行します。
#
# インストール前に実行したいスクリプトの定義
# $1: 1=最初のインストール、2=アップグレート
# %%pre

#
# インストール後に実行したいスクリプトの定義
# $1: 1=最初のインストール、2=アップグレート
%post
##if [ "$1" = 1 ]; then
/usr/bin/perl /tmp/install_mod.sh %{MACHINE}
/bin/rm -f /tmp/install_mod.sh
##fi


#
# アンインストール前に実行するスクリプトの定義
# $1: 0=アンインストール、1=アップグレード
# %%preun
#
# アンインストール後に実行するスクリプトの定義
# $1: 0=アンインストール、1=アップグレード
%postun
##if [ "$1" = 0 ]; then
	/bin/sed -i -e '/ARIB-STD-B24/d'    %{LIB_DIR}/gconv-modules
	/bin/sed -i -e '/EN300-468-TAB00/d' %{LIB_DIR}/gconv-modules
##fi
	/usr/sbin/iconvconfig

#
# 更新履歴
# %%changelog以下にパッケージの更新履歴を英語で記述します。
# 最新の更新情報が上にくるように書きます。
# 一行目の最初に * を書き、日付と変更を加えた人の名前を書きます。
# 二行目以降に - を書き、更新内容を書きます。
# 今日の日付は date コマンド で LANG=C; date +'%%a %%b %%d %%Y' とすると確認できます。
# 12月1日のように日の部分が一桁の場合は 0 をつけ 01 のようにします。
%changelog
* Sun Apr 14 2024 kazuhiro WATANABE <watanabe439@gmail.com> 2.0.1-1
- Added handling of invalid code for additional character sets..
- Some ARIB strings somehow require that EXTRA_SYMBOLS codepoints fallback to KANJI_set.
* Mon Aug 14 2023 kazuhiro WATANABE <watanabe439@gmail.com> 2.0.0-2
- fixed "Error: Missing dependency:libc.so.6(GLIBC_PRIVATE)(64bit) is Required by gconv-digital-tv-2.0.0-1.x86_64".
* Tue May 09 2023 kazuhiro WATANABE <watanabe439@gmail.com> 2.0.0-1
- support RHEL8/9.
* Wed Aug 12 2015 kazuhiro WATANABE <watanabe439@gmail.com> 1.0.0-3
- support 32/64 compile option by rpmbuild define option.
* Wed Jul 01 2015 kazuhiro WATANABE <watanabe439@gmail.com> 1.0.0-2
- fixed wrong conversion to ARIB STD-B24.
* Thu Jun 18 2015 Kazuhiro WATANABE <watanabe439@gmail.com> 1.0.0-1
- corresponds to the RPM package.
#
